import 'package:flutter/material.dart';
import 'package:flutter_compute_tree/flutter_compute_tree.dart';

import 'src/app.dart';

var handlerCalled = 0;

class AsyncHandlerTriggerApp extends App {
  const AsyncHandlerTriggerApp({super.key});

  @override
  String get name => 'trigger.asyncHandler()';

  @override
  Widget build(CTNode n) {
    final loadTrigger = n.trigger();

    final result = loadTrigger.asyncHandler((_) async {
      ++handlerCalled;
      await Future.delayed(const Duration(seconds: 1));
      return 'Loaded';
    });

    n.invoke(loadTrigger);

    return Column(
      mainAxisAlignment: MainAxisAlignment.center,
      children: [
        Text(result.runtimeType.toString()),
        const SizedBox(height: 16),
        if (result is Failure) Text(result.failure().toString()),
        if (result is Success) Text(result.success().value),
        const SizedBox(height: 16),
        ElevatedButton(
          onPressed: loadTrigger,
          child: const Text('Load'),
        ),
        const SizedBox(height: 16),
        Text('Handler called: $handlerCalled'),
      ],
    );
  }
}
