import 'package:flutter/material.dart';
import 'package:flutter_compute_tree/flutter_compute_tree.dart';

import 'src/app.dart';

class InvokeApp extends App {
  const InvokeApp({super.key});

  @override
  String get name => 'n.invoke()';

  @override
  Widget build(CTNode n) {
    final counter = n.ref(() => 0);
    final key = counter.value ~/ 3;

    final invokeResult = n.invoke(
      () => counter.value ~/ 3,
      key,
    );

    return Column(
      mainAxisAlignment: MainAxisAlignment.center,
      children: [
        const Text('You have pushed the button this many times:'),
        Text(
          '${counter.value}',
          style: Theme.of(n.context).textTheme.headlineMedium,
        ),
        const SizedBox(height: 16),
        Text(
          'Invokes: $invokeResult',
          style: Theme.of(n.context).textTheme.bodyMedium,
        ),
        const SizedBox(height: 16),
        ElevatedButton(
          onPressed: () {
            counter.value++;
          },
          child: const Text('Increment'),
        ),
      ],
    );
  }
}
