import 'package:flutter/material.dart';
import 'package:flutter_compute_tree/flutter_compute_tree.dart';

import 'src/app.dart';

class MemoApp extends App {
  const MemoApp({super.key});

  @override
  String get name => 'n.memo()';

  @override
  Widget build(CTNode n) {
    final counter = n.ref(() => 0);
    final increment = n.memo(() => counter.value++);

    return Column(
      mainAxisAlignment: MainAxisAlignment.center,
      children: [
        const Text('You have pushed the button this many times:'),
        Text(
          '${counter.value}',
          style: Theme.of(n.context).textTheme.headlineMedium,
        ),
        const SizedBox(height: 16),
        Text(
          'increment hashCode: ${increment.hashCode}',
          style: Theme.of(n.context).textTheme.headlineMedium,
        ),
        const SizedBox(height: 16),
        ElevatedButton(
          onPressed: () {
            counter.value++;
          },
          child: const Text('Increment'),
        ),
      ],
    );
  }
}
