import 'dart:math';

import 'package:flutter/material.dart';
import 'package:flutter_compute_tree/flutter_compute_tree.dart';

import 'src/app.dart';

final r = Random();

int key() {
  final v = r.nextInt(100);
  if (v < 90) {
    return 0;
  }

  return 1;
}

class RefApp extends App {
  const RefApp({super.key});

  @override
  String get name => 'ref()';

  @override
  Widget build(CTNode n) {
    final k = key();
    final counter = n.ref(() => 0, k);

    return Column(
      mainAxisAlignment: MainAxisAlignment.center,
      children: [
        const Text('You have pushed the button this many times:'),
        Text(
          '${counter.value}',
          style: Theme.of(n.context).textTheme.headlineMedium,
        ),
        const SizedBox(height: 16),
        Text(
          'key: $k',
          style: Theme.of(n.context).textTheme.headlineSmall,
        ),
        const SizedBox(height: 16),
        ElevatedButton(
          onPressed: () {
            counter.value++;
          },
          child: const Text('Increment'),
        ),
      ],
    );
  }
}
