import 'package:flutter/material.dart';
import 'package:flutter_compute_tree/flutter_compute_tree.dart';

import 'src/app.dart';

class RefActionApp extends App {
  const RefActionApp({super.key});

  @override
  String get name => 'ref.action()';

  @override
  Widget build(CTNode n) {
    final counter = n.ref(() => 0);

    final increment = counter.action((value, _) => value + 1);
    final decrement = counter.action((value, _) => value - 1);

    return Column(
      mainAxisAlignment: MainAxisAlignment.center,
      children: [
        const Text('You have pushed the button this many times:'),
        Text(
          '${counter.value}',
          style: Theme.of(n.context).textTheme.headlineMedium,
        ),
        const SizedBox(height: 16),
        ElevatedButton(
          onPressed: increment,
          child: const Text('Increment'),
        ),
        ElevatedButton(
          onPressed: decrement,
          child: const Text('Decrement'),
        ),
      ],
    );
  }
}
