import 'package:flutter/material.dart';
import 'package:flutter_compute_tree/flutter_compute_tree.dart';

import 'src/app.dart';

Stream<int> stream() async* {
  for (var i = 0; i < 10; i++) {
    await Future.delayed(const Duration(seconds: 1));
    yield i;
  }
}

class StreamSubscriptionApp extends App {
  const StreamSubscriptionApp({super.key});

  @override
  String get name => 'n.subscribeToStream()';

  @override
  Widget build(CTNode n) {
    final streamIdRef = n.ref(() => 0);
    final nextStream = streamIdRef.action((value, _) => ++value);

    final v = n.subscribeToStream(
      () => stream(),
      initialValue: -1,
      dep: streamIdRef.value,
    );

    return Scaffold(
      body: Center(
        child: Column(
          mainAxisSize: MainAxisSize.min,
          children: [
            Text('Stream ID: ${streamIdRef.value}'),
            const SizedBox(height: 20),
            Text(
              v.success().value.toString(),
              style: const TextStyle(fontSize: 40),
            ),
            const SizedBox(height: 20),
            ElevatedButton(
              onPressed: nextStream,
              child: const Text('Next Stream'),
            ),
          ],
        ),
      ),
    );
  }
}
