import 'package:flutter/material.dart';
import 'package:flutter_compute_tree/flutter_compute_tree.dart';

import 'src/app.dart';

class TriggerHandlerApp extends App {
  const TriggerHandlerApp({super.key});

  @override
  String get name => 'trigger.handler()';

  @override
  Widget build(CTNode n) {
    final counter = n.ref(() => 0);
    final increment = n.trigger();

    final count = increment.handler(
      (_) => ++counter.value,
      counter.value,
    );

    return Column(
      mainAxisAlignment: MainAxisAlignment.center,
      children: [
        const Text('You have pushed the button this many times:'),
        Text(
          '$count',
          style: Theme.of(n.context).textTheme.headlineMedium,
        ),
        const SizedBox(height: 16),
        ElevatedButton(
          onPressed: increment,
          child: const Text('Increment'),
        ),
      ],
    );
  }
}
