import 'package:flutter/material.dart';
import 'package:flutter_compute_tree/flutter_compute_tree.dart';

import 'src/app.dart';

class ValueListenableSubscriptionApp extends App {
  const ValueListenableSubscriptionApp({super.key});

  @override
  String get name => 'n.subscribeToValueListenable()';

  @override
  Widget build(CTNode n) {
    final vnIdRef = n.ref(() => 0);
    final vn = n.ref(() => ValueNotifier(0), vnIdRef.value);

    final increment = vn.action((value, _) {
      value.value++;
      return value;
    });

    final nextVn = vnIdRef.action((value, _) => ++value);

    final v = n.subscribeToValueListenable(() => vn.value, vnIdRef.value);

    return Scaffold(
      body: Center(
        child: Column(
          mainAxisSize: MainAxisSize.min,
          children: [
            Text('ValueNotifier ID: ${vnIdRef.value}'),
            const SizedBox(height: 20),
            Text(
              v.toString(),
              style: const TextStyle(fontSize: 40),
            ),
            const SizedBox(height: 20),
            ElevatedButton(
              onPressed: increment,
              child: const Text('Increment'),
            ),
            const SizedBox(height: 20),
            ElevatedButton(
              onPressed: nextVn,
              child: const Text('Next ValueNotifier'),
            ),
          ],
        ),
      ),
    );
  }
}
