part of '../lib.dart';

class _ValueListenableUnit<T, K> extends Unit<T, K> {
  final ValueListenable<T> Function() factory;
  late ValueListenable<T> listenable;

  _ValueListenableUnit(this.factory);

  @override
  void init(CTNode node, K dep) {
    super.init(node, dep);

    listenable = factory();
    listenable.addListener(notify);
  }

  @override
  void dispose() {
    listenable.removeListener(notify);
    super.dispose();
  }

  @override
  T unwrap() {
    return listenable.value;
  }
}
