part of 'lib.dart';

abstract class Unit<T, K> {
  late UnitKey<T, K> key;
  late CTNode owner;

  void notify() {
    owner._signalUpdate();
  }

  @mustCallSuper
  void init(CTNode node, K dep) {
    owner = node;
  }

  @mustCallSuper
  Unit<T, K> update(
    CTNode node,
    K oldDep,
    K newDep,
    covariant Unit<T, K> newUnit,
  ) {
    owner = node;

    if (oldDep == newDep) {
      return this;
    } else {
      return newUnit;
    }
  }

  @mustCallSuper
  void dispose() {}

  T unwrap();
}
