part of 'lib.dart';

class UnitEntry<T, K> {
  UnitKey<T, K> key;
  Unit<T, K> unit;
  final CTNode node;

  UnitEntry(this.key, this.unit, this.node) {
    unit.key = key;
  }

  void init(K dep) {
    unit.init(node, dep);
  }

  void update(K oldDep, UnitKey<T, K> newKey, covariant Unit<T, K> newUnit) {
    key = newKey;

    final oldUnit = unit;
    unit = unit.update(node, oldDep, newKey._value, newUnit);

    if (oldUnit != unit) {
      oldUnit.dispose();
      unit.init(node, newKey._value);
    }
  }

  void dispose() {
    unit.dispose();
  }
}
